Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2008)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2011)
@@ -953,49 +810,561 @@
 
 
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Initialization of the wall surface model
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_init_material_model
+!> Sum up and time-average urban surface output quantities as well as allocate
+!> the array necessary for storing the average.
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_average_3d_data( mode, variable )
 
         IMPLICIT NONE
 
-        INTEGER(iwp) ::  k, l            ! running indices
-        
-        CALL location_message( '    initialization of wall surface model', .TRUE. )
-       
-        !-- Calculate wall grid spacings. 
-        !-- Temperature is defined at the center of the wall layers,
-        !-- whereas gradients/fluxes are defined at the edges (_stag)
-        DO l = nzb_wall, nzt_wall
-           zwn(l) = zwn_default(l)
+        CHARACTER (len=*), INTENT(IN) ::  mode
+        CHARACTER (len=*), INTENT(IN) :: variable
+  
+        INTEGER(iwp)                                       :: i, j, k, l, ids, iwl,istat
+        CHARACTER (len=20)                                 :: var, surfid
+        INTEGER(iwp), PARAMETER                            :: nd = 5
+        CHARACTER(len=6), DIMENSION(0:nd-1), PARAMETER     :: dirname = (/ '_roof ', '_south', '_north', '_west ', '_east ' /)
+
+!--     find the real name of the variable
+        var = TRIM(variable)
+        DO i = 0, nd-1
+            k = len(TRIM(var))
+            j = len(TRIM(dirname(i)))
+            IF ( var(k-j+1:k) == dirname(i) )  THEN
+                ids = i
+                var = var(:k-j)
+                EXIT
+            ENDIF
         ENDDO
-        
-        !-- apply for all particular wall grids
-        DO l = startenergy, endenergy
-           zw(:,l) = zwn(:) * thickness_wall(l)
-           dz_wall(nzb_wall,l) = zw(nzb_wall,l)
-           DO k = nzb_wall+1, nzt_wall
-               dz_wall(k,l) = zw(k,l) - zw(k-1,l)
-           ENDDO
+        IF ( ids == -1 )  THEN
+            var = TRIM(variable)
+        ENDIF
+        IF ( var(1:11) == 'usm_t_wall_'  .AND.  len(TRIM(var)) >= 12 )  THEN
+!--          wall layers
+            READ(var(12:12), '(I1)', iostat=istat ) iwl
+            IF ( istat == 0  .AND.  iwl >= nzb_wall  .AND.  iwl <= nzt_wall )  THEN
+                var = var(1:10)
+            ELSE
+!--             wrong wall layer index
+                RETURN
+            ENDIF
+        ENDIF
+
+        IF ( mode == 'allocate' )  THEN
            
-           dz_wall(nzt_wall+1,l) = dz_wall(nzt_wall,l)
-
-           DO k = nzb_wall, nzt_wall-1
-               dz_wall_stag(k,l) = 0.5 * (dz_wall(k+1,l) + dz_wall(k,l))
-           ENDDO
-           dz_wall_stag(nzt_wall,l) = dz_wall(nzt_wall,l)
+           SELECT CASE ( TRIM( var ) )
+                
+                CASE ( 'usm_radnet' )
+!--                 array of complete radiation balance
+                    IF ( .NOT.  ALLOCATED(rad_net_av) )  THEN
+                        ALLOCATE( rad_net_av(startenergy:endenergy) )
+                        rad_net_av = 0.0_wp
+                    ENDIF
+                    
+                CASE ( 'usm_rad_insw' )
+!--                 array of sw radiation falling to surface after i-th reflection
+                    IF ( .NOT.  ALLOCATED(surfinsw_av) )  THEN
+                        ALLOCATE( surfinsw_av(startenergy:endenergy) )
+                        surfinsw_av = 0.0_wp
+                    ENDIF
+                                    
+                CASE ( 'usm_rad_inlw' )
+!--                 array of lw radiation falling to surface after i-th reflection
+                    IF ( .NOT.  ALLOCATED(surfinlw_av) )  THEN
+                        ALLOCATE( surfinlw_av(startenergy:endenergy) )
+                        surfinlw_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_rad_inswdir' )
+!--                 array of direct sw radiation falling to surface from sun
+                    IF ( .NOT.  ALLOCATED(surfinswdir_av) )  THEN
+                        ALLOCATE( surfinswdir_av(startenergy:endenergy) )
+                        surfinswdir_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_rad_inswdif' )
+!--                 array of difusion sw radiation falling to surface from sky and borders of the domain
+                    IF ( .NOT.  ALLOCATED(surfinswdif_av) )  THEN
+                        ALLOCATE( surfinswdif_av(startenergy:endenergy) )
+                        surfinswdif_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_rad_inswref' )
+!--                 array of sw radiation falling to surface from reflections
+                    IF ( .NOT.  ALLOCATED(surfinswref_av) )  THEN
+                        ALLOCATE( surfinswref_av(startenergy:endenergy) )
+                        surfinswref_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_rad_inlwdif' )
+!--                 array of sw radiation falling to surface after i-th reflection
+                    IF ( .NOT.  ALLOCATED(surfinlwdif_av) )  THEN
+                        ALLOCATE( surfinlwdif_av(startenergy:endenergy) )
+                        surfinlwdif_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_rad_inlwref' )
+!--                 array of lw radiation falling to surface from reflections
+                    IF ( .NOT.  ALLOCATED(surfinlwref_av) )  THEN
+                        ALLOCATE( surfinlwref_av(startenergy:endenergy) )
+                        surfinlwref_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_rad_outsw' )
+!--                 array of sw radiation emitted from surface after i-th reflection
+                    IF ( .NOT.  ALLOCATED(surfoutsw_av) )  THEN
+                        ALLOCATE( surfoutsw_av(startenergy:endenergy) )
+                        surfoutsw_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_rad_outlw' )
+!--                 array of lw radiation emitted from surface after i-th reflection
+                    IF ( .NOT.  ALLOCATED(surfoutlw_av) )  THEN
+                        ALLOCATE( surfoutlw_av(startenergy:endenergy) )
+                        surfoutlw_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_rad_hf' )
+!--                 array of heat flux from radiation for surfaces after i-th reflection
+                    IF ( .NOT.  ALLOCATED(surfhf_av) )  THEN
+                        ALLOCATE( surfhf_av(startenergy:endenergy) )
+                        surfhf_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_wshf' )
+!--                 array of sensible heat flux from surfaces
+!--                 land surfaces
+                    IF ( .NOT.  ALLOCATED(wshf_eb_av) )  THEN
+                        ALLOCATE( wshf_eb_av(startenergy:endenergy) )
+                        wshf_eb_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_wghf' )
+!--                 array of heat flux from ground (wall, roof, land)
+                    IF ( .NOT.  ALLOCATED(wghf_eb_av) )  THEN
+                        ALLOCATE( wghf_eb_av(startenergy:endenergy) )
+                        wghf_eb_av = 0.0_wp
+                    ENDIF
+
+                CASE ( 'usm_t_surf' )
+!--                 surface temperature for surfaces
+                    IF ( .NOT.  ALLOCATED(t_surf_av) )  THEN
+                        ALLOCATE( t_surf_av(startenergy:endenergy) )
+                        t_surf_av = 0.0_wp
+                    ENDIF
+                    
+                CASE ( 'usm_t_wall' )
+!--                 wall temperature for iwl layer of walls and land
+                    IF ( .NOT.  ALLOCATED(t_wall_av) )  THEN
+                        ALLOCATE( t_wall_av(nzb_wall:nzt_wall,startenergy:endenergy) )
+                        t_wall_av = 0.0_wp
+                    ENDIF
+
+               CASE DEFAULT
+                   CONTINUE
+
+           END SELECT
+
+        ELSEIF ( mode == 'sum' )  THEN
+           
+           SELECT CASE ( TRIM( var ) )
+                
+                CASE ( 'usm_radnet' )
+!--                 array of complete radiation balance
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            rad_net_av(l) = rad_net_av(l) + rad_net_l(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_rad_insw' )
+!--                 array of sw radiation falling to surface after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinsw_av(l) = surfinsw_av(l) + surfinsw(l)
+                        ENDIF
+                    ENDDO
+                             
+                CASE ( 'usm_rad_inlw' )
+!--                 array of lw radiation falling to surface after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinlw_av(l) = surfinlw_av(l) + surfinlw(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_rad_inswdir' )
+!--                 array of direct sw radiation falling to surface from sun
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinswdir_av(l) = surfinswdir_av(l) + surfinswdir(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_rad_inswdif' )
+!--                 array of difusion sw radiation falling to surface from sky and borders of the domain
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinswdif_av(l) = surfinswdif_av(l) + surfinswdif(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_rad_inswref' )
+!--                 array of sw radiation falling to surface from reflections
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinswref_av(l) = surfinswref_av(l) + surfinsw(l) - &
+                                                surfinswdir(l) - surfinswdif(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_rad_inlwdif' )
+!--                 array of sw radiation falling to surface after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinlwdif_av(l) = surfinlwdif_av(l) + surfinlwdif(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_rad_inlwref' )
+!--                 array of lw radiation falling to surface from reflections
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinlwref_av(l) = surfinlwref_av(l) + &
+                                                surfinlw(l) - surfinlwdif(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_rad_outsw' )
+!--                 array of sw radiation emitted from surface after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfoutsw_av(l) = surfoutsw_av(l) + surfoutsw(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_rad_outlw' )
+!--                 array of lw radiation emitted from surface after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfoutlw_av(l) = surfoutlw_av(l) + surfoutlw(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_rad_hf' )
+!--                 array of heat flux from radiation for surfaces after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfhf_av(l) = surfhf_av(l) + surfhf(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_wshf' )
+!--                 array of sensible heat flux from surfaces (land, roof, wall)
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            wshf_eb_av(l) = wshf_eb_av(l) + wshf_eb(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_wghf' )
+!--                 array of heat flux from ground (wall, roof, land)
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            wghf_eb_av(l) = wghf_eb_av(l) + wghf_eb(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_t_surf' )
+!--                 surface temperature for surfaces
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            t_surf_av(l) = t_surf_av(l) + t_surf(l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_t_wall' )
+!--                 wall temperature for  iwl layer of walls and land
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            t_wall_av(iwl, l) = t_wall_av(iwl,l) + t_wall(iwl, l)
+                        ENDIF
+                    ENDDO
+                    
+                CASE DEFAULT
+                    CONTINUE
+
+           END SELECT
+
+        ELSEIF ( mode == 'average' )  THEN
+           
+           SELECT CASE ( TRIM( var ) )
+                
+                CASE ( 'usm_radnet' )
+!--                 array of complete radiation balance
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            rad_net_av(l) = rad_net_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_rad_insw' )
+!--                 array of sw radiation falling to surface after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinsw_av(l) = surfinsw_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+                                    
+                CASE ( 'usm_rad_inlw' )
+!--                 array of lw radiation falling to surface after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinlw_av(l) = surfinlw_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_rad_inswdir' )
+!--                 array of direct sw radiation falling to surface from sun
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinswdir_av(l) = surfinswdir_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_rad_inswdif' )
+!--                 array of difusion sw radiation falling to surface from sky and borders of the domain
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinswdif_av(l) = surfinswdif_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_rad_inswref' )
+!--                 array of sw radiation falling to surface from reflections
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinswref_av(l) = surfinswref_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_rad_inlwdif' )
+!--                 array of sw radiation falling to surface after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinlwdif_av(l) = surfinlwdif_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_rad_inlwref' )
+!--                 array of lw radiation falling to surface from reflections
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfinlwref_av(l) = surfinlwref_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_rad_outsw' )
+!--                 array of sw radiation emitted from surface after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfoutsw_av(l) = surfoutsw_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_rad_outlw' )
+!--                 array of lw radiation emitted from surface after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfoutlw_av(l) = surfoutlw_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_rad_hf' )
+!--                 array of heat flux from radiation for surfaces after i-th reflection
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            surfhf_av(l) = surfhf_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_wshf' )
+!--                 array of sensible heat flux from surfaces (land, roof, wall)
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            wshf_eb_av(l) = wshf_eb_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_wghf' )
+!--                 array of heat flux from ground (wall, roof, land)
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            wghf_eb_av(l) = wghf_eb_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+
+                CASE ( 'usm_t_surf' )
+!--                 surface temperature for surfaces
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            t_surf_av(l) = t_surf_av(l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+                    
+                CASE ( 'usm_t_wall' )
+!--                 wall temperature for  iwl layer of walls and land
+                    DO l = startenergy, endenergy
+                        IF ( surfl(id,l) == ids )  THEN
+                            t_wall_av(iwl, l) = t_wall_av(iwl,l) / REAL( average_count_3d, kind=wp )
+                        ENDIF
+                    ENDDO
+                
+           END SELECT
+
+        ENDIF
+
+    END SUBROUTINE usm_average_3d_data
+
+
+!------------------------------------------------------------------------------!
+!> Calculates radiation absorbed by box with given size and LAD.
+!>
+!> Simulates resol**2 rays (by equally spacing a bounding horizontal square
+!> conatining all possible rays that would cross the box) and calculates
+!> average transparency per ray. Returns fraction of absorbed radiation flux
+!> and area for which this fraction is effective.
+!------------------------------------------------------------------------------!
+    PURE SUBROUTINE usm_box_absorb(boxsize, resol, dens, uvec, area, absorb)
+        IMPLICIT NONE
+
+        REAL(wp), DIMENSION(3), INTENT(in) :: &
+            boxsize, &      !< z, y, x size of box in m
+            uvec            !< z, y, x unit vector of incoming flux
+        INTEGER(iwp), INTENT(in) :: &
+            resol           !< No. of rays in x and y dimensions
+        REAL(wp), INTENT(in) :: &
+            dens            !< box density (e.g. Leaf Area Density)
+        REAL(wp), INTENT(out) :: &
+            area, &         !< horizontal area for flux absorbtion
+            absorb          !< fraction of absorbed flux
+        REAL(wp) :: &
+            xshift, yshift, &
+            xmin, xmax, ymin, ymax, &
+            xorig, yorig, &
+            dx1, dy1, dz1, dx2, dy2, dz2, &
+            crdist, &
+            transp
+        INTEGER(iwp) :: &
+            i, j
+
+        xshift = uvec(3) / uvec(1) * boxsize(1)
+        xmin = min(0._wp, -xshift)
+        xmax = boxsize(3) + max(0._wp, -xshift)
+        yshift = uvec(2) / uvec(1) * boxsize(1)
+        ymin = min(0._wp, -yshift)
+        ymax = boxsize(2) + max(0._wp, -yshift)
+
+        transp = 0._wp
+        DO i = 1, resol
+            xorig = xmin + (xmax-xmin) * (i-.5_wp) / resol
+            DO j = 1, resol
+                yorig = ymin + (ymax-ymin) * (j-.5_wp) / resol
+
+                dz1 = 0._wp
+                dz2 = boxsize(1)/uvec(1)
+
+                IF ( uvec(2) > 0._wp )  THEN
+                    dy1 = -yorig             / uvec(2) !< crossing with y=0
+                    dy2 = (boxsize(2)-yorig) / uvec(2) !< crossing with y=boxsize(2)
+                ELSE IF ( uvec(2) < 0._wp )  THEN
+                    dy1 = (boxsize(2)-yorig) / uvec(2) !< crossing with y=boxsize(2)
+                    dy2 = -yorig             / uvec(2) !< crossing with y=0
+                ELSE !uvec(2)==0
+                    dy1 = -huge(1._wp)
+                    dy2 = huge(1._wp)
+                ENDIF
+
+                IF ( uvec(3) > 0._wp )  THEN
+                    dx1 = -xorig             / uvec(3) !< crossing with x=0
+                    dx2 = (boxsize(3)-xorig) / uvec(3) !< crossing with x=boxsize(3)
+                ELSE IF ( uvec(3) < 0._wp )  THEN
+                    dx1 = (boxsize(3)-xorig) / uvec(3) !< crossing with x=boxsize(3)
+                    dx2 = -xorig             / uvec(3) !< crossing with x=0
+                ELSE !uvec(1)==0
+                    dx1 = -huge(1._wp)
+                    dx2 = huge(1._wp)
+                ENDIF
+
+                crdist = max(0._wp, (min(dz2, dy2, dx2) - max(dz1, dy1, dx1)))
+                transp = transp + exp(-ext_coef * dens * crdist)
+            ENDDO
         ENDDO
-        
-        ddz_wall      = 1.0_wp / dz_wall
-        ddz_wall_stag = 1.0_wp / dz_wall_stag
-        
-        CALL location_message( '    wall structures filed out', .TRUE. )
-
-        CALL location_message( '    initialization of wall surface model finished', .TRUE. )
-
-    END SUBROUTINE usm_init_material_model
-
+        transp = transp / resol**2
+        area = (boxsize(3)+xshift)*(boxsize(2)+yshift)
+        absorb = 1._wp - transp
+        
+    END SUBROUTINE usm_box_absorb
+    
+    
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This subroutine splits direct and diffusion dw radiation
+!> It sould not be called in case the radiation model already does it
+!> It follows <CITATION>
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_calc_diffusion_radiation 
+    
+        REAL(wp), PARAMETER                          ::  sol_const = 1367.0_wp   !< solar conbstant
+        REAL(wp), PARAMETER                          :: lowest_solarUp = 0.1_wp  !< limit the sun elevation to protect stability of the calculation
+        INTEGER(iwp)                                 :: i, j
+        REAL(wp), PARAMETER                          ::  year_seconds = 86400._wp * 365._wp
+        REAL(wp)                                     ::  year_angle              !< angle
+        REAL(wp)                                     ::  etr                     !< extraterestrial radiation
+        REAL(wp)                                     ::  corrected_solarUp       !< corrected solar up radiation
+        REAL(wp)                                     ::  horizontalETR           !< horizontal extraterestrial radiation
+        REAL(wp)                                     ::  clearnessIndex          !< clearness index
+        REAL(wp)                                     ::  diff_frac               !< diffusion fraction of the radiation
+
+        
+!--     Calculate current day and time based on the initial values and simulation time
+        year_angle = ((day_init*86400) + time_utc_init+time_since_reference_point) &
+                       / year_seconds * 2.0_wp * pi
+        
+        etr = sol_const * (1.00011_wp +                                            &
+                          0.034221_wp * cos(year_angle) +                          &
+                          0.001280_wp * sin(year_angle) +                          &
+                          0.000719_wp * cos(2.0_wp * year_angle) +                 &
+                          0.000077_wp * sin(2.0_wp * year_angle))
+        
+!--    
+!--     Under a very low angle, we keep extraterestrial radiation at
+!--     the last small value, therefore the clearness index will be pushed
+!--     towards 0 while keeping full continuity.
+!--    
+        IF ( zenith(0) <= lowest_solarUp )  THEN
+            corrected_solarUp = lowest_solarUp
+        ELSE
+            corrected_solarUp = zenith(0)
+        ENDIF
+        
+        horizontalETR = etr * corrected_solarUp
+        
+        DO i = nxlg, nxrg
+            DO j = nysg, nyng
+                clearnessIndex = rad_sw_in(0,j,i) / horizontalETR
+                diff_frac = 1.0_wp / (1.0_wp + exp(-5.0033_wp + 8.6025_wp * clearnessIndex))
+                rad_sw_in_diff(j,i) = rad_sw_in(0,j,i) * diff_frac
+                rad_sw_in_dir(j,i)  = rad_sw_in(0,j,i) * (1.0_wp - diff_frac)
+                rad_lw_in_diff(j,i) = rad_lw_in(0,j,i)
+            ENDDO
+        ENDDO
+        
+    END SUBROUTINE usm_calc_diffusion_radiation
+    
 
 !------------------------------------------------------------------------------!
@@ -1029,16 +1398,16 @@
         INTEGER(kind=MPI_ADDRESS_KIND)              :: size_lad_rma
     
-        !-- calculation of the SVF
+!--     calculation of the SVF
         CALL location_message( '    calculation of SVF and CSF', .TRUE. )
 
-        !-- precalculate face areas for different face directions using normal vector
+!--     precalculate face areas for different face directions using normal vector
         DO d = 0, 9
             facearea(d) = 1._wp
-            IF (idir(d) == 0) facearea(d) = facearea(d) * dx
-            IF (jdir(d) == 0) facearea(d) = facearea(d) * dy
-            IF (kdir(d) == 0) facearea(d) = facearea(d) * dz
+            IF ( idir(d) == 0 ) facearea(d) = facearea(d) * dx
+            IF ( jdir(d) == 0 ) facearea(d) = facearea(d) * dy
+            IF ( kdir(d) == 0 ) facearea(d) = facearea(d) * dz
         ENDDO
 
-        !-- initialize variables and temporary arrays for calculation of svf and csf
+!--     initialize variables and temporary arrays for calculation of svf and csf
         nsvfl  = 0
         ncsfl  = 0
@@ -1047,5 +1416,5 @@
         ALLOCATE( asvf1(nsvfla) )
         asvf => asvf1
-        IF ( plant_canopy ) THEN
+        IF ( plant_canopy )  THEN
             ncsfla = gasize
             mcsf   = 1
@@ -1054,5 +1423,5 @@
         ENDIF
         
-        !-- initialize temporary terrain and plant canopy height arrays (global 2D array!)
+!--     initialize temporary terrain and plant canopy height arrays (global 2D array!)
         ALLOCATE( nzterr(0:(nx+1)*(ny+1)-1) )
 #if defined( __parallel )
@@ -1065,5 +1434,5 @@
         nzterr = RESHAPE( nzb_s_inner(nys:nyn,nxl:nxr), (/(nx+1)*(ny+1)/) )
 #endif
-        IF (plant_canopy) THEN
+        IF ( plant_canopy )  THEN
             ALLOCATE( plantt(0:(nx+1)*(ny+1)-1) )
 #if defined( __parallel )
@@ -1075,5 +1444,5 @@
             DEALLOCATE(planthl)
 
-            IF ( usm_lad_rma ) THEN
+            IF ( usm_lad_rma )  THEN
                 CALL MPI_Info_create(minfo, ierr)
                 CALL MPI_Info_set(minfo, 'accumulate_ordering', '', ierr)
@@ -1082,22 +1451,12 @@
                 CALL MPI_Info_set(minfo, 'same_disp_unit', 'true', ierr)
 
-                !-- Allocate and initialize the MPI RMA window
-                !-- must be in accordance with allocation of lad_s in plant_canopy_model
-                !-- optimization of memory should be done
-                !-- Argument X of function c_sizeof(X) needs arbitrary REAL(wp) value, set to 1.0_wp for now
+!--             Allocate and initialize the MPI RMA window
+!--             must be in accordance with allocation of lad_s in plant_canopy_model
+!--             optimization of memory should be done
+!--             Argument X of function c_sizeof(X) needs arbitrary REAL(wp) value, set to 1.0_wp for now
                 size_lad_rma = c_sizeof(1.0_wp)*nnx*nny*nzu
                 CALL MPI_Win_allocate(size_lad_rma, c_sizeof(1.0_wp), minfo, comm2d, &
                                         lad_s_rma_p, win_lad, ierr)
-                IF ( debug_prints ) THEN
-                    WRITE(9,*) 'MPI_Win_allocate', myid, ierr
-                    FLUSH(9)
-                ENDIF
                 CALL c_f_pointer(lad_s_rma_p, lad_s_rma, (/ nzu, nny, nnx /))
-                !IF ( debug_prints ) THEN
-                !    WRITE(9,*) 'lad_s', 'tsize=',c_sizeof(lad_s(0,0,0)), 'size=',c_sizeof(lad_s), &
-                !        'nnz=', nnz, lbound(lad_s, 1), ubound(lad_s, 1), nzb, nzt, &
-                !        'nny=', nny, lbound(lad_s, 2), ubound(lad_s, 2), nys, nyn, &
-                !        'nnx=', nnx, lbound(lad_s, 3), ubound(lad_s, 3), nxl, nxr
-                !ENDIF
                 usm_lad(nzub:, nys:, nxl:) => lad_s_rma(:,:,:)
             ELSE
@@ -1117,11 +1476,7 @@
 
 #if defined( __parallel )
-            IF ( usm_lad_rma ) THEN
+            IF ( usm_lad_rma )  THEN
                 CALL MPI_Info_free(minfo, ierr)
                 CALL MPI_Win_lock_all(0, win_lad, ierr)
-                IF ( debug_prints ) THEN
-                    WRITE(9,*) 'MPI_Win_lock_all', myid, ierr
-                    FLUSH(9)
-                ENDIF
             ELSE
                 ALLOCATE( usm_lad_g(0:(nx+1)*(ny+1)*nzu-1) )
